/********************************************/
/* Name:      TV3DCpp Header				*/
/* Copyright: Truevision3D LLC				*/
/* Version:   v0.9							*/
/* Webpage:   http://www.truevision3d.com	*/
/* Tested On: VC++ 6.0						*/
/*------------------------------------------*/
/* Based On:  MadProgrammers StdAfx header  */
/********************************************/

#ifndef TV3D_ENGINE_HEADER
#define TV3D_ENGINE_HEADER

#define WIN32_LEAN_AND_MEAN

typedef int DSCAPS;
//
#ifndef D3DVECTOR_DEFINED
typedef struct D3DVECTOR
{
	float x;
	float y;
	float z;
} D3DVECTOR; 
#define D3DVECTOR_DEFINED
#endif


/*
 *	DX Objects 
 */
typedef void* Direct3DSurface8Ptr;
typedef void* ID3DXPtr;
typedef void* Direct3DDevice8Ptr;
typedef void* Direct3DTexture8Ptr;
typedef void* DirectInputDevice8Ptr;
typedef void* ID3DX8Ptr;
typedef void* Direct3D8Ptr;
typedef void* D3DXRenderToSurfacePtr;
typedef void* D3DXMeshPtr;


/*
 *	Defines
 */
#define tvtrue VARIANT_TRUE
#define tvfalse VARIANT_FALSE


// *	TV3DMedia Declarations (Not working)
 //*//*

//typedef void* DirectSound3DBuffer8Ptr;

//#import "h:\tv3dsdk4\bin\tvmedia.dll" named_guids 

//using namespace TV3DMedia;
//
//typedef _TVSoundDevice				*ITVSoundDevice;
//typedef _TVSoundDevices				*ITVSoundDevices;
//typedef _TVSoundWaveStereo			*ITVSoundWaveStereo;
//typedef _TVSoundMP3					*ITVSoundMP3;
//typedef _Enums						*IEnums;
//typedef _TVSounds					*ITVSounds;
//typedef _TVSoundWave3D				*ITVSoundWave3D;
//typedef _TVListener					*ITVListener;
//typedef _TVSoundCD					*ITVSoundCD;
//typedef _TVSoundEngine				*ITVSoundEngine;
//typedef _TVSoundModule				*ITVSoundModule;
//typedef _TVEffects					*ITVEffects;
//typedef _TVEffect					*ITVEffect;
//typedef _TVPlaylist					*ITVPlaylist;
//typedef _TVPlaylistElement			*ITVPlaylistElement;
//typedef _TVDLSCollection			*ITVDLSCollection;
//typedef _TVSoundDX3D				*ITVSoundDX3D;
//typedef _TVSoundDXStereo			*ITVSoundDXStereo;
//typedef _TVMovie					*ITVMovie;/*


/*
 *	Declaration of the Interface Creating functions (NotWorking)
 *//*

ITVSoundDevice			CreateTVSoundDevice();
ITVSoundDevices			CreateTVSoundDevices();
ITVSoundWaveStereo		CreateTVSoundWaveStereo();
ITVSoundMP3				CreateTVSoundMP3();
IEnums					CreateEnums();
ITVSounds				CreateTVSounds();
ITVSoundWave3D			CreateTVSoundWave3D();
ITVListener				CreateTVListner();
ITVSoundCD				CreateSoundCD();
ITVSoundEngine			CreateTVSoundEngine();
ITVSoundModule			CreateTVSoundModule();
ITVEffects				CreateTVEffects();
ITVEffect				CreateTVEffect();
ITVPlaylist				CreateTVPlaylist();
ITVPlaylistElement		CreateTVPlaylistElement();
ITVDLSCollection		CreateTVDLSCollection();
ITVSoundDX3D			CreateTVSoundDX3D();
ITVSoundDXStereo		CreateTVSoundDXStereo();
ITVMovie				CreateTVMovie();/*


/*
 *	TV3DEngine declarations
 */
#import "c:\tv3dsdk\bin\truevision3d.dll" named_guids 

#include <d3d8.h>
using namespace TrueVision3D;

typedef _TVActor				*ITVActor;
typedef _TVActor2				*ITVActor2;
typedef _TVAI					*ITVAI;
typedef _TVAtmosphere			*ITVAtmosphere;
typedef _TVBitmapParts			*ITVBitmapParts;
typedef _TVBSPTree				*ITVBSPTree;
typedef	_TVCamera				*ITVCamera;
typedef	_TVCameraFactory		*ITVCameraFactory;
typedef	_TVCollisionResult		*ITVCollisionResult;
typedef _TVDelphiGlobals		*ITVGlobals;
typedef _TVEngine				*ITVEngine;
typedef _TVForceFeedEffect		*ITVForceFeedEffect;
typedef _TVForceFeedEffects		*ITVForceFeedEffects;
typedef _TVGameController		*ITVGameController;
typedef _TVGameControllers		*ITVGameControllers;
typedef _TVGraphicEffect		*ITVGraphicEffect;
typedef _TVInputEngine			*ITVInputEngine;
typedef _TVInternalObjects		*ITVInternalObjects;
typedef _TVKeyFrameAnim			*ITVKeyFrameAnim;
typedef _TVLandscape			*ITVLandscape;
typedef _TVLightEngine			*ITVLightEngine;
typedef _TVMaterialFactory		*ITVMaterialFactory;
typedef _TVMesh					*ITVMesh;
typedef _TVParticleSystem		*ITVParticleSystem;
typedef _TVPath					*ITVPath;
typedef _TVRenderSurface		*ITVRenderSurface;
typedef _TVScene				*ITVScene;
typedef _TVScreen2DImmediate	*ITVScreen2DImmediate;
typedef _TVScreen2DText			*ITVScreen2DText;
typedef _TVTextureFactory		*ITVTextureFactory;
typedef _TVTileMap				*ITVTileMap;
typedef _TVViewport				*ITVViewport;

/*
 *	Declaration of the Interface Creating functions
 */
ITVActor				CreateTVActor();
ITVActor2				CreateTVActor2();
ITVAI					CreateTVAI();
ITVAtmosphere			CreateTVAtmosphere();
ITVBitmapParts			CreateTVBitmapParts();
ITVBSPTree				CreateTVBSPTree();
ITVCamera				CreateTVCamera();
ITVCameraFactory		CreateTVCameraFactory();
ITVCollisionResult		CreateTVCollisionResult();
ITVGlobals				CreateTVGlobals();
ITVEngine				CreateTVEngine();
ITVForceFeedEffect		CreateTVFeedEffect();	 
ITVForceFeedEffects		CreateTVFeedEffects();
ITVGameController		CreateTVGameController();
ITVGameControllers		CreateTVGameControllers();
ITVGraphicEffect		CreateTVGraphicEffect();
ITVInputEngine			CreateTVInputEngine();
ITVInternalObjects		CreateTVInternalObjects();
ITVKeyFrameAnim			CreateTVKeyFrameAnim();
ITVLandscape			CreateTVLandscape();
ITVLightEngine			CreateTVLightEngine();
ITVMaterialFactory		CreateTVMaterialFactory();
ITVParticleSystem		CreateTVParticleSystem();
ITVPath					CreateTVPath();
ITVScene				CreateTVScene();
ITVScreen2DImmediate	CreateTVScreen2DImmediate();
ITVScreen2DText			CreateTVScreen2DText();
ITVTextureFactory		CreateTVTextureFactory();
ITVTileMap				CreateTVTileMap();
ITVViewport				CreateTVViewport();



#define LIGHT(a) (TrueVision3D::D3DLIGHT8 *)(a)


typedef ::_D3DLIGHT8 TV_LIGHT ;

/*
 *	Declaration of the Extra/Macro functions
 */

//RGBA returns the color in hex format, the arguments are 0-1
unsigned int RGBA(float r, float g, float b, float a);

//Extracts the path of a file, if you pass the GetModuleFileName path,
//it will return the path where it is existing, the Application Path
void AppPath(char* PathOfFile,char* ret_Path);

// light color
inline _D3DCOLORVALUE LightColor(float r, float g, float b, float a)
{
   _D3DCOLORVALUE cv;
   cv.r = r;
   cv.g = g;
   cv.b = b;
   cv.a = a;
   return cv;
}

// Some strings conversion routines.
// For example when you need to return a string from the TV3D DLL
BSTR ConvertStringToBSTR(const char* pSrc);
char* ConvertBSTRToString(BSTR pSrc);

// Don't forget to free the memory allocated by these functions.
#endif